<?php
  
namespace App\Http\Controllers;
  
use Illuminate\Http\Request;
use Mail;
use App\Mail\DemoMail;
use App\Models\User;
  
class MailController extends Controller
{
    /**
     * Write code on Method
     *
     * @return response()
     */
    public function index(Request $request)
    {
        $mailData = [
            'title' => 'Mail from datland.tech',
            'body' => $request->all()
        ];
        
        if(count($request->all()) > 2){
            // sending email to client so email will be changed with client's email
            Mail::to('datland@customdev.devopdigital.com')->send(new DemoMail($mailData));
        }else{
            $user = User::where('id',$request->user_id)->first();    
            $user->is_subscriber = 1;
            $user->save();
            // sending email to user so here email will be changed by request->email
            Mail::to('datland@customdev.devopdigital.com')->send(new DemoMail($mailData));
        }
        return response(['status'=>200]);
    }
    
    public function checkSubscriber($id){
        $user = User::where('id',$id)->first();
        if($user->is_subscriber	== 1){
            return response(['data'=>'true']);
        }else{
            return response(['data'=>'false']);
        }
    }
}