<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Order;
use App\Models\Orderitem;

class OrderController extends Controller
{
    public function store(Request $request){
        $orderItemData = $request->orderItems;
        $order = new Order();
        $order->user_id = $request->userId;
        $order->first_name = $request->firstName;
        $order->last_name = $request->lastName;
        $order->email = $request->email;
        $order->contact = $request->contact;
        $order->company_name = $request->companyName;
        $order->street_address = $request->streetAddress;
        $order->city = $request->city;
        $order->state = $request->state;
        $order->country = $request->country;
        $order->zip = $request->zipCode;
        if($order->save()){

        foreach($orderItemData as $data){
            Orderitem::create([
                'order_id' => $order->id,
                'product_id' => $data['product_id'],
                'product_qty' => $data['product_qty'],
                'product_name' => $data['product_name'],
                'product_price' => $data['product_price'],
                'product_image' => $data['product_image']
            ]);
        }
            return response(['status'=>'200']);
        }else{
            return response(['status'=>'404']);
        }
    }

    public function show(){
        $orders = Order::orderBy('id', 'desc')->get();
        return response($orders);
    }
    
    public function showOrderByUser($userId){
        $orders = Order::where('user_id',$userId)->get();
        return response($orders);
    }
    
    
    public function orderDetails($orderid){
        $order = Order::where('id',$orderid)->first();
        if($order){
            return response(
                [
                    'data'=>$order,
                    'status'=>'200'
                ]
            );
        }else{
            return response([
                'data'=>'',
                'status'=>'404'
            ]);
        }

    }
    public function changeOrderStatus(Request $request, $orderid){
        $order = Order::where('id',$orderid)->first();
        $order->status = $request->currentStatus;
        if($order->save()){
            return response(
                [
                    'data'=>$order,
                    'status'=>'200'
                ]
            );
        }else{
            return response([
                'data'=>'',
                'status'=>'404'
            ]);
        }

    }



}


