<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;



class PaymentController extends Controller
{
    public function charge(Request $request) {
        $stripe = new \Stripe\StripeClient(env('STRIPE_SECRET_KEY'));

        try {
            // Process payment using $request data and the Stripe object
            // Charge user's card and handle success or failure
            // Return a response to the client

            // Create a Payment Intent
                $paymentIntent = $stripe->paymentIntents->create([
                    'amount' => $request->input('amount'), // Amount in cents
                    'currency' => 'usd',
                    'payment_method' => $request->input('payment_method_id'),
                    'confirmation_method' => 'manual',
                    'confirm' => true,
                ]);

                // If payment is successful
                if ($paymentIntent->status === 'succeeded') {
                    return response()->json(['message' => 'Payment successful'], 200);
                } else {
                    // Handle payment failure
                    return response()->json(['error' => 'Payment failed'], 400);
                }

        } catch (\Exception $e) {
            // Handle payment error
            return response()->json(['error' => $e->getMessage()], 500);
        }
    }
}


