<?php

namespace App\Http\Controllers;

use Illuminate\Support\Facades\Storage;
use App\Models\Product;

use Illuminate\Http\Request;

class ProductController extends Controller
{
    public function store(Request $request){
        // $product = new Product();
        // $product->name = $request->name;
        // $product->description = $request->description;
        // $product->calculated_price = $request->price;
        // if($request->has('image')){
        //         if(isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on')   
        //              $url = "https://";   
        //         else  
        //              $url = "http://";   
        //         // Append the host(domain name, ip) to the URL.   
        //         $url.= $_SERVER['HTTP_HOST'];   
        //         $product->images = 'Product Image File: STD28000N__66832.jpg, Product Image URL: '.$url.'/public/'.$request->file('image')->store('products');
        // }
        // $result = $product->save();
        // if($result){
        //     return $product;
        // }else{
        //     return response([
        //         'error'=>'Product Could Not Be Stored'
        //     ]);
        // }
        
       
    $request->validate([
    'name' => 'required|string',
    'description' => 'required|string',
    'price' => 'required|numeric',
    'image' => 'required|file|mimes:jpeg,png,gif,webp|max:2048',
    ]);
    
    try {
        $product = new Product();
        $product->name = $request->name;
        $product->description = $request->description;
        $product->calculated_price = $request->price;
    
        if ($request->has('image')) {
            $uploadedFile = $request->file('image');
        
            // Store the file using Laravel's storage system
            $filePath = $uploadedFile->store('products');
            
            // Generate the full URL, including the base URL and the path returned by Storage::url
            $product->images = 'Product Image File: ' . $uploadedFile->getClientOriginalName() . ', Product Image URL: ' . 'https://datland.dev.digtalsdesigns.com/'.Storage::url('app/'.$filePath);
        }

    
        $result = $product->save();
    
        if ($result) {
            return response(['data' => $product]);
        } else {
            return response(['error' => 'Product Could Not Be Stored']);
        }
    } catch (\Exception $e) {
        // Log the exception for further investigation
        \Log::error('Exception during product creation: ' . $e->getMessage());
        return response(['error' => 'Internal Server Error'], 500);
    }

            

    }

    public function update(Request $request,$id){
        $product = Product::find($id);
        $product->name = $request->name;
        $product->description = $request->description;
        $product->calculated_price = (int)$request->price; 
        if ($request->has('image')) {
            $uploadedFile = $request->file('image');
        
            // Store the file using Laravel's storage system
            $filePath = $uploadedFile->store('products');
            
            // Generate the full URL, including the base URL and the path returned by Storage::url
            $product->images = 'Product Image File: ' . $uploadedFile->getClientOriginalName() . ', Product Image URL: ' . 'https://datland.dev.digtalsdesigns.com/'.Storage::url('app/'.$filePath);
        }
        $result = $product->save();
        if($result){
            return response([
                'status'=>200,
                'error'=>''
                ]);
        }else{
            return response([
                'status'=>404,
                'error'=>'Product Could Not Be Updated'
            ]);
        }
    }

    public function show(){
        $products = Product::all();
        return response($products);
    }

    public function delete($id){
        $result = Product::where('id',$id)->delete();
        if($result){
            return response(['status'=>'200']);
        }else{
            return response(['status'=>'404']);
        }

    }

    public function productDetails($id){
        $result = Product::where('id',$id)->first();
        if($result){
            return response([
                'data'=>$result,
                'status'=>'200'
            ]);
        }else{
            return response(['status'=>'404']);
        }

    }
    
    public function searchedProductDetails(Request $request){
        $result = Product::where('name',$request->searched)->first();
        if($result){
            return response([
                'data'=>$result,
                'status'=>'200'
            ]);
        }else{
            return response(['status'=>'404']);
        }

    }
    

}
