<?php

namespace App\Http\Controllers;

use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{
    public function register(Request $request){
        $user = new User();
        $user->name = $request->input('name');
        $user->email = $request->input('email');
        $user->password = Hash::make($request->input('password'));
        if($user->save()){
            return $user;
        }else{
            return response([
                'status'=>404
            ]);
        }


    }

    public function login(Request $request){
        $user = User::where('email',$request->email)->first();
        if(!$user || !Hash::check($request->password,$user->password)){
            return response([
                'error'=>'Email/password does not match !!'
            ]);
        }else{
            return response([
                'error'=>'',
                'user'=>$user
            ]);

        }
    }
    public function update(Request $request,$id){
        $User = User::find($id);
        if($request->has('name')){
            $User->name = $request->name;
        }
        if($request->has('newPassword')){
            $User->password = Hash::make($request->newPassword);
        }
        // if($request->has('image')){
        //     $User->image_path = $request->file('image')->store('Users');
        // }
        $result = $User->save();
        if($result){
            return $User;
        }else{
            return response([
                'error'=>'User Could Not Be Updated'
            ]);
        }
    }

    public function show(){
        $users = User::orderBy('id', 'desc')->get();
        return response($users);
    }

    public function delete($id){
        $result = User::where('id',$id)->delete();
        if($result){
            return response(['status'=>'200']);
        }else{
            return response(['status'=>'404']);
        }

    }

    public function UserDetails($id){
        $result = User::where('id',$id)->first();
        if($result){
            return response([
                'data'=>$result,
                'status'=>'200'
            ]);
        }else{
            return response(['status'=>'404']);
        }


    }




}
