<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\WebsiteSetting;

class WebsiteSettingController extends Controller
{
    public function store(Request $request){
        $WebsiteSetting = new WebsiteSetting();
        $WebsiteSetting->name = $request->name;
        $WebsiteSetting->description = $request->description;
        $WebsiteSetting->price = $request->price;
        if($request->has('image')){
            $WebsiteSetting->image_path = $request->file('image')->store('WebsiteSettings');
        }
        $result = $WebsiteSetting->save();
        if($result){
            return $WebsiteSetting;
        }else{
            return response([
                'error'=>'WebsiteSetting Could Not Be Stored'
            ]);
        }
    }

    public function update(Request $request){
        $result =null;
        foreach($request->all() as $key=>$data){
            $setting = WebsiteSetting::where('name',$key)->first();
            if($setting != ''){
                $setting->value = $data;
                $result = $setting->save();
            }
        }
        // $WebsiteSetting = WebsiteSetting::all;
        // $WebsiteSetting->name = $request->name;
        // $WebsiteSetting->description = $request->description;
        // $WebsiteSetting->price = $request->price;
        // if($request->has('image')){
        //     $WebsiteSetting->image_path = $request->file('image')->store('WebsiteSettings');
        // }

        if($result){
            return response([
                'status'=>'200'
            ]);
        }else{
            return response([
                'error'=>'WebsiteSetting Could Not Be Updated'
            ]);
        }
    }

    public function show(){
        $websiteSettings = WebsiteSetting::all();
        if($websiteSettings){
            return response([
                'status'=>'200',
                'data'=>$websiteSettings
            ]);
        }else{
            return response([
                'status'=>'404',
                'data'=>''
            ]);
        }
    }

    public function delete($id){
        $result = WebsiteSetting::where('id',$id)->delete();
        if($result){
            return response(['status'=>'200']);
        }else{
            return response(['status'=>'404']);
        }

    }

    public function WebsiteSettingDetails($id){
        $result = WebsiteSetting::where('id',$id)->first();
        if($result){
            return response([
                'data'=>$result,
                'status'=>'200'
            ]);
        }else{
            return response(['status'=>'404']);
        }

    }
}
