<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\OrderitemController;
use App\Http\Controllers\WebsiteSettingController;
use App\Http\Controllers\MailController;
use App\Http\Controllers\PaymentController;
use App\Http\Controllers\NewproductController;
use App\Http\Controllers\TestimonialController;





/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "api" middleware group. Make something great!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});
// for users
Route::post('/register',[UserController::class,'register']);
Route::post('/login',[UserController::class,'login']);
Route::post('/update-user/{id}',[UserController::class,'update']);
Route::get('/show-users',[UserController::class,'show']);
Route::delete('/delete-user/{id}',[UserController::class,'delete']);
Route::get('/user-details/{id}',[UserController::class,'userDetails']);


// for products
Route::post('/store-products',[ProductController::class,'store']);
Route::post('/update-product/{id}',[ProductController::class,'update']);
Route::get('/show-products',[ProductController::class,'show']);
Route::delete('/delete-product/{id}',[ProductController::class,'delete']);
Route::get('/product-details/{id}',[ProductController::class,'productDetails']);
Route::get('/searched-product-details',[ProductController::class,'searchedProductDetails']);


// for testimonial
Route::post('/store-testimonial',[TestimonialController::class,'store']);
Route::get('/show-testimonials',[TestimonialController::class,'show']);
Route::delete('/delete-testimonial/{id}',[TestimonialController::class,'delete']);
Route::post('/update-testimonial/{id}',[TestimonialController::class,'update']);
Route::get('/testimonial-details/{id}',[TestimonialController::class,'testimonialDetails']);
Route::get('/searched-testimonial-details',[TestimonialController::class,'searchedProductDetails']);

//  products form csv
// Route::get('/show-new-products',[NewproductController::class,'show']);
// Route::get('/new-product-details/{id}',[NewproductController::class,'productDetails']);
// Route::get('/product-details/{id}',[NewproductController::class,'productDetails']);
// Route::post('/update-product/{id}',[NewproductController::class,'update']);


// for orders
Route::post('/order/store',[OrderController::class,'store']);
Route::get('/show-orders',[OrderController::class,'show']);
Route::get('/show-orders/{userid}',[OrderController::class,'showOrderByUser']);
Route::get('/show-order-details/{id}',[OrderController::class,'orderDetails']);
Route::post('/change-order-status/{orderid}',[OrderController::class,'changeOrderStatus']);


// for order items
Route::post('/orderitems/store',[OrderitemController::class,'store']);
Route::get('/orderitems/{orderid}',[OrderitemController::class,'orderItems']);
Route::get('/orderitems/show',[OrderitemController::class,'showItems']);



// for website settings
Route::post('/store-setting',[WebsiteSettingController::class,'store']);
Route::post('/update-settings',[WebsiteSettingController::class,'update']);
Route::get('/show-settings',[WebsiteSettingController::class,'show']);
// Route::delete('/delete-product/{id}',[WebsiteSettingController::class,'delete']);
// Route::get('/product-details/{id}',[WebsiteSettingController::class,'productDetails']);


// email
Route::post('/subscription-store', [MailController::class, 'index']);
Route::get('/check-subscriber/{id}', [MailController::class, 'checkSubscriber']);

// stripe
Route::post('/charge', 'PaymentController@charge');
